echo(version=version());

JEU = 0.7;
INFINI = 1000;
H= INFINI;
D= 8 + JEU;
D_ECROU = 13;
H_ECROU = 7;

//piece_sans_ecrou();
piece_avec_ecrou();


module toupie() {
color("pink" , 0.5)
    translate([0, 0, 18])
        rotate_extrude($fn = 80)
            polygon( points=[[0,0],[4,0],[13,10],[20,18],[0,18]] );
}

module axe(H,D) {
    color("yellow" , 0.5)
       cylinder(h = H , d = D , center = true);
    }
    
module ecrou() {
    translate([0,0,0])
    linear_extrude(height = H_ECROU, center = false, convexity = 10, twist = 0)
    circle(r=(D_ECROU + JEU) / 2,$fn=6);
    }
    
module piece_sans_ecrou() {
    difference() {
        union() {
        translate([0,0,36]) rotate([180,0,0]) toupie();
        }
        axe(H,D);
        }
    }
    
module piece_avec_ecrou() {
    difference() {
        union() {
        translate([0,0,36]) rotate([180,0,0]) toupie();
        }
        axe(H,D);
        ecrou();
        }
    }